#!/usr/local/bin/perl -w

# gold.pl - version 0.2

# Copyright (C) 2001-2002.
# Ted Perdersen, University Of Minnesota, Duluth.
# tpederse@d.umn.edu
# Nitin Varma, University Of Minnesota, Duluth.
# varm0003@d.umn.edu


# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


# ----------------------------------------------------------------------------
#                             Main Program
# ----------------------------------------------------------------------------

# package required for command line options
use Getopt::Long;



GetOptions("version", "help");


if ( defined $opt_help ) { $help = $opt_help; }
else                     { $help = 0; }


if ( defined $opt_version ) { $version = $opt_version; }
else                        { $version = 0; } 

# if asked for help, print the help and exit.  
if ( $help )
{
    &printHelp();
    exit;
}

# if asked for version, print the version number and exit
if ( $version )
{
    &printVersion();
    exit;
}



if($#ARGV < 2 )
{
    
    &printUsage();
    exit;
}

open(e_file, $ARGV[0]) || die "Error opening file $ARGV[0]\n";
open(f_file, $ARGV[1])  || die "Error opening file $ARGV[1]\n";
open(ef_file, $ARGV[2])  || die "Error opening file $ARGV[2]\n";
while($ef_line = <ef_file>)
{
    
   if($ef_line =~ m/^SENT/)
   {
       $#e_array = 0;
       $#f_array = 0;
       $e_line = <e_file>;
       @e_array = split(/ /, $e_line);
       $f_line = <f_file>;
       @f_array = split(/ /, $f_line);
   }
   elsif($ef_line =~ m/^S /)
   {
       @array = split(/ /, $ef_line);
       $alignment = "$e_array[$array[1]]"." -> "."$f_array[$array[2]]";
       $hash{$alignment}++;
   }
   
 }
    

foreach $line(keys %hash)
{
    print "$line\n";
}
   
# ---------------------------------------------------------------------------
#                                 USER DEFINED FUNCTIONS
# ---------------------------------------------------------------------------

# prints what are the command line options for the program and explain what
# input is required by different arguments
sub printHelp{

    &printUsage();
    print "OPTIONS:";
    print "\n\n  --version     Prints the version number";
    print "\n\n  --help        Prints the help message\n";
 
}



# prints the usage of the program.
sub printUsage{

 print "Usage:gold.pl E_FILE1 F_FILE2 EF_FILE\n";
 print "\nE_FILE - is the English file";
 print "\nF_FILE - is theFrench file";
 print "\nEF_FILE - is the alignment file\n";
}




# prints the version number and copyright information.
sub printVersion{

    print "gold.pl -  Version 0.2\n";
    print "Copyright (C) 2001-2002, Ted Pedersen & Nitin Varma\n";

}



          
 
